/*
 
	MAKE LADY MILLION A POINTER AND NEW HER
 */
#include <string>
#include <iostream>
#include "allegro.h"
#include "main.h"
#include "math.h"
#include "time.h"
#include "mathroutines.h"

const int levelcount=5;


#include "gamestructs.h"
#include "gametext.h"
#include "sound.h"

using std::string;

//if platform appears over person, push them down
//screen transition code...to move between two screens...or screen and config screen, &c. (different for each, because blah blah blah...
//can draw the whole level background at once
//ladder level?
//introduce maxy variable...
//deal with intersections in calcfalling and canmoveup commands

/*BOSS TRANSITION
kill all non-barrier sprites
put megaman in fall mode
	frames 0 - 20, retract barrier
	frames whatever-whatever - lift megaman up
	frames blah-blah+20 put back barrier
start playing boss music
create boss (have it warp on screen?)
*/

void deleteentity(Entity *e);
void addentity(Entity *e);
void addenemy(Entity *e);
void addbullet(Entity *e);

const int screenheight=8;
const int levelheight[levelcount]={6,5,5,5,5};

//actually gives radius*sin(theta)
const int radius=tilesize;
int Sin[360];
int Cos[360];

//0 should be level here
bool mask[screenheight*5];

//bottom tile is top tile of previous screen


void explode(BITMAP* bmp, int x, int y, int t, bool limit=true)
{
	int l;
	if (limit)
		l=min (1+t,30);
	else
		l=1+t*t;
	
	for (int i=0;i<tilesize;i++)
		for (int j=0;j<tilesize;j++)
		{
			masked_blit(bmp,buffer,i,j,x+i+( ((i+j)%2==0)*2-1  )*l*cos(t),y+j-l*sin(t),1,1);
		}
}

class Particle: public Entity
{
	public:
		BITMAP *sprite;
		Vector dir;
		void draw() {
			masked_blit(sprite,buffer,0,0,x,screencoord(y),size.x,size.y);
		};
		void move() {
			//add code to check for other bounds some time...
			x+=dir.x;
			y+=dir.y;
			if (x>=10*tilesize)
			{	
				deleteentity(this);
			}
		}
		Particle(int p_x,int p_y, int v_x, int v_y, int width, int height, BITMAP *p_img) {
			sprite=p_img;
			dir.x=v_x;
			dir.y=v_y;
			x=p_x;
			y=p_y;
			size.x=width;
			size.y=height;
		}
};

#include "ladymillionstructs.h"
#include "specimenstructs.h"
#include "pandastructs.h"

int playerscreencoord()
{
	int y=entities[0]->y;
	int r=0;
	//3 is levelheight-2
	if ((gamestate==mm_level)||(gamestate==mm_boss)) {
		if (y/(screenheight*tilesize)>(levelheight[level]-2))
			r=max(y%(screenheight*tilesize),(screenheight*tilesize)/2);
		else if (y/(screenheight*tilesize)==0)
			r=y;								  //=min(y,(screenheight*tilesize)/2);
		else
			r=(screenheight*tilesize)/2;
	}
	else if (gamestate==mm_bosstransition) {
		int a=(20+2*tilesize);
		r=((screenheight*tilesize)/2*(a-min(statetimer,a))+y*(min(statetimer,a)))/a;
	}
	return r;
}

int screencoord(int y)
{
	return y-entities[0]->y+playerscreencoord();
}

void deleteforboss()
{
	int ec=entitycount;
	for (int i=2;i<ec;i++)
		deleteentity(entities[2]);
}

void deleteallentities()
{
	for (int i=0;i<entitycount;i++)
		delete entities[i];
	entitycount=0;
	platformcount=0;
	bulletcount=0;
	enemycount=0;
}
void deleteentity(Entity *e)
{
	int entityindex=-1;
	int enemyindex=-1;
	int bulletindex=-1;
	int platformindex=-1;

	for (int i=0;i<entitycount;i++) {
		if (e==entities[i]) {
			entityindex=i;
			break;
		}
	}

	for (int i=0;i<enemycount;i++) {
		if (e==enemies[i]) {
			enemyindex=i;
			break;
		}
	}

	for (int i=0;i<bulletcount;i++) {

		if (e==bullets[i]) {
			bulletindex=i;
			break;
		}
	}

	for (int i=0;i<platformcount;i++) {
		if (e==platforms[i]) {
			platformindex=i;
			break;
		}
	}

	if (entityindex>=0) {
		delete entities[entityindex];
		for (int i=entityindex+1;i<entitycount;i++) {
			entities[i-1]=entities[i];
		}
		entitycount--;

		if( bulletindex>=0) {
			for (int i=bulletindex+1;i<bulletcount;i++) {
				bullets[i-1]=bullets[i];
			}
			bulletcount--;
		}

		if( enemyindex>=0) {
			for (int i=enemyindex+1;i<enemycount;i++) {
				enemies[i-1]=enemies[i];
			}
			enemycount--;
		}

		if( platformindex>=0) {
			for (int i=platformindex+1;i<platformcount;i++) {
				platforms[i-1]=platforms[i];
			}
			platformcount--;
		}
	}

}

void addentity(Entity *e)
{
	if (entitycount<(maxentities-1)) {
		entities[entitycount]=e;
		entitycount++;
	}
else
	delete e;
}

void addbullet(Entity *e)
{
	if (bulletcount<(maxbullets)) {
		bullets[bulletcount]=e;
		bulletcount++;
		switch (e->damage) 
		{
			case 0:
				playsample(s_shoot);
				break;
			case 1:
				playsample(s_milk);
				break;
			case 2:
				playsample(s_hair);
				break;
			case 3:
				playsample(s_baby);
				break;
			case 4:
				playsample(s_bag);//bag effect...
				break;
		}
		addentity(e);
	}
	else
		delete e;
}

/*gameplay stuff*/
void addplatform(Platform *e)
{
	if (platformcount<(maxplatforms-1)) {
		platforms[platformcount]=e;
		platformcount++;
		addentity(e);
	}
	else
		delete e;
}

void addenemy(Entity *e)
{
	if (enemycount<(maxenemies-1)) {
		enemies[enemycount]=e;
		enemycount++;
		addentity(e);
	}
	else
		delete e;
}

/* FRAMERATE CONTROL*/

void mm_initlevel()
{
	playerdead=false;
	bossdead=false;
	starttimer=startpause;
	endtimer=0;
	
	bulletcount=0;

	maxy=screenheight*(levelheight[level])*tilesize-tilesize;
	destroy_bitmap(background);
	background=create_bitmap(tilesize*3,tilesize*(screenheight*levelheight[level]+1));

	drawbackground();
	//Load tileset into buffer;

	
	/*
	 
	 Smashcrate
	 
	 */

	//standard sprites that need to appear in this order and in these positions.
	player=new Player();
	addentity(player);
	
	addplatform(new Bossbarrier());

#include "levels.h"
	
	for (int i=0;i<maxentities;i++)
	{
		if (levelstruct[level][i][0]!=e_done)
		{
			switch(levelstruct[level][i][0])
			{
				case e_platform:
					addplatform(new Platform(levelstruct[level][i][1],levelstruct[level][i][2],levelstruct[level][i][3],levelstruct[level][i][4]));
					break;
				case e_pplatform:
					addplatform(new Platform(levelstruct[level][i][1],levelstruct[level][i][2],levelstruct[level][i][3],levelstruct[level][i][4],true));
					break;					
				case e_smashcrate:
					addplatform(new Smashcrate(levelstruct[level][i][1]));
					break;
				case e_conveyor:
					addplatform(new Conveyor(levelstruct[level][i][1],levelstruct[level][i][2],levelstruct[level][i][3],levelstruct[level][i][4]));
					break;
				case e_helmetdude:
					addenemy(new Helmetdude(levelstruct[level][i][1]));
					break;		
				case e_spinner:
					addenemy(new Spinner(levelstruct[level][i][1]));
					break;
				case e_spike:
					addenemy(new Spike(levelstruct[level][i][1],levelstruct[level][i][2],levelstruct[level][i][3],levelstruct[level][i][4]));
					break;
				case e_rickety:
					addplatform(new Ricketyplatform(levelstruct[level][i][1]));					
					break;
				case e_bird:
					addenemy(new Bird(levelstruct[level][i][1],levelstruct[level][i][2]));
					break;
			}
		}
		else break;
	}

		 /*
		  player=new Player();

	//player always has index 0, boss transition always has index 1;
	addentity(player);

	Platform *p= new Bossbarrier();
	addplatform(p);

	addplatform( new Smashcrate(maxy-tilesize*2));
	//	addenemy(new Spike(maxy-tilesize*4,100,200,200));
	//
	p= new Platform(maxy-tilesize*5,0,100,200);
	addplatform(p);

	addenemy(new Helmetdude(maxy-tilesize*7));
	p= new Platform(maxy-tilesize*8,100,200,200);
	addplatform(p);
	p= new Platform(maxy-tilesize*11,0,100,200);
	addplatform(p);
	p= new Platform(maxy-tilesize*14,100,200,200);
	addplatform(p);
	p= new Platform(maxy-tilesize*17,0,100,200);
	addplatform(p);
	p= new Platform(maxy-tilesize*20,100,200,200);
	addplatform(p);
	p= new Platform(maxy-tilesize*23,0,100,200);
	addplatform(p);
	p= new Platform(maxy-tilesize*26,100,200,200);
	addplatform(p);
	p= new Platform(maxy-tilesize*29,0,100,200);
	addplatform(p);
	//	p= new Platform(maxy-tilesize*32,100,200,200);
	//	addentity(p);
	//	addplatform(p);
	//	p= new Platform(maxy-tilesize*35,0,100,200);
	//	addentity(p);
	//	addplatform(p);
*/
}

int tileoffset(int l)
{
	if (level<4) return level;
	else return 14;
}

void drawbackground()
{

	int lvl=tileoffset(level);

	//main level background
	clear_to_color(background,makecol(255,255,255));
	//draw top
	for (int j=5; j<9;j++) {
		blit(leveltiles[lvl][j],background,0,0,(j-5)*tilesize,0,tilesize,tilesize);
	}

	//	blit (leveltiles[7][0],background,0,0,tilesize,0,tilesize,tilesize);
	//draw middle
	for (int i=1;i<screenheight*levelheight[level];i++) {
		//draw left wall
		blit(leveltiles[lvl][0],background,0,0,0,i*tilesize,tilesize,tilesize);
		//draw right wall
		blit(leveltiles[lvl][1],background,0,0,tilesize*2,i*tilesize,tilesize,tilesize);
	}
	//draw bottom
	for (int j=2; j<5;j++) {
		blit(leveltiles[lvl][j],background,0,0,(j-2)*tilesize,tilesize*screenheight*levelheight[level],tilesize,tilesize);
	}

}

void mmdraw()
{

	//1: draw background
	//blit(background,buffer,0,tilesize*screenheight*yoffset(),3*tilesize,0,3*tilesize,144);
	//blit(background,buffer,0,min(py-(screenheight*tilesize)/2,tilesize*screenheight*4),3*tilesize,0,3*tilesize,144);
	blit(background,buffer,0,-screencoord(0),3*tilesize,0,3*tilesize,144);
	//2: draw sprites
	for (int i=1;i<entitycount;i++)
		entities[i]->draw();
/*
 
 INCLUDE SEXY TIMING ANIMATION HERE
 
 verticle sections alternating whether they're coming from above or below.  YEAH!
 
 */
	if (starttimer==0)
	{
		if (endtimer==0)
			entities[0]->draw();
		else if (bossdead)
		{
			if ((level!=4)&&(!mm_completed[level]))
			{
			if (endtimer<20)
			{
				explode(leveltiles[9+level][0], tilesize*4, (tilesize*(endtimer)+(100)*(20-endtimer))/20, 80-endtimer);
			}
				else
				{
			if (endtimer<=60)
				for (int i=0;i<tilesize;i++)
					masked_blit(playertiles[0],buffer,0,i,tilesize*4+(((i%2)*2)-1)*(60-endtimer)*(60-endtimer),playerscreencoord()+i,tilesize,1);
			else
				entities[0]->draw();
			
			if (endtimer<=80)
				explode(leveltiles[9+level][0], tilesize*4, tilesize, 80-endtimer);
				}
			}
			else
			{
				entities[0]->draw();
				
				explode(leveltiles[9+level][0], tilesize*4, tilesize, 80-endtimer,false);
				
			}
		}
		else if (playerdead)
		{
				explode(playertiles[0], tilesize*4, playerscreencoord(), min(endpause-endtimer,200),false );
		}
	}
	else
	{
		if (starttimer>=10)
			for (int i=0;i<tilesize;i++)
				masked_blit(playertiles[0],buffer,0,i,tilesize*4+(((i%2)*2)-1)*((starttimer-10)*(starttimer-10)),playerscreencoord()+i,tilesize,1);
		else if (starttimer>=5)
			for (int j=0;j<tilesize;j++)
				masked_blit(playertiles[0],buffer,j,0,tilesize*4+j,playerscreencoord()+(((j%2)*2)-1)*((10-starttimer)*(10-starttimer)),1,tilesize);
		else
			for (int j=0;j<tilesize;j++)
				masked_blit(playertiles[0],buffer,j,0,tilesize*4+j,playerscreencoord()+(((j%2)*2)-1)*(starttimer*starttimer)/2,1,tilesize);
				
	}
	if (gamestate==mm_paused)
	{
		clear_to_color(buffer,makecol(0,0,0));
	}
	
	//3: draw health bar
	blit(healthbar[0],buffer,0,0,3,9,9,47);
	blit(healthbar[1],buffer,2,1,5,10+(maxhealth-player->health)*2,5,(player->health)*2);
	blit(leveltiles[6][1+(player->weapon)],buffer,0,0,4,48,7,7);

	
	if (gamestate==mm_boss)
	{
		blit(healthbar[0],buffer,0,0,160-3-9,9,9,47);
		blit(healthbar[1],buffer,2,1,160-3-9+2,10+(maxhealth-(boss->health)/2)*2,5,((boss->health)/2)*2);
		blit(leveltiles[6][1+((level+1)%5)],buffer,0,0,160-3-9+1,48,7,7);
	}
	
}

//timer stuff

volatile unsigned int frames, fps;
void second_counter(void)
{
	fps=frames;
	frames=0;
} END_OF_FUNCTION(second_counter);
int timewaster_delay;
extern void do_prog(void);

volatile unsigned int ticks;
void ticker(void)
{
	++ticks;
} END_OF_FUNCTION(ticker);

int chartonum(char c)
{
	if ((c>=97)&&(c<=122))
		return c-97;
	else if ((c>=48)&&(c<=57))
		return (26+c-48);
	else return -1;
}

void print_text(const char *s,  int x, int y)
{
	int i=0;
	while (s[i]!=0)
	{
		if (chartonum(s[i])>=0)
			masked_stretch_blit(fontbmp[chartonum(s[i])],buffer,0,0,3,5,x+12*i,y,9,15);
		i++;
	}
}

void print_text_to(const char *s, int l, int x, int y)
{
	int i=0;
	while (s[i]!=0&&(i<l))
	{
		if (chartonum(s[i])>=0)
			masked_stretch_blit(fontbmp[chartonum(s[i])],buffer,0,0,3,5,x+12*i,y,9,15);
		i++;
	}	
}


void print_textsmall(const char *s, int x, int y)
{
	int i=0;
	while (s[i]!=0)
	{
		if (chartonum(s[i])>=0)
			masked_stretch_blit(fontbmp[chartonum(s[i])],buffer,0,0,3,5,x+8*i,y,6,10);
		i++;
	}
}


void print_num(int n, int x, int y)
{
//aligned right by default
int d=1;
int i=1;
do	{

		masked_stretch_blit(fontbmp[(n/d)%10+26],buffer,0,0,3,5,x-12*i,y,9,15);
		d*=10;
		i++;
	}
while ((n/d)!=0);

}


void menu_input()
{
	if (!key[KEY_SPACE])
		spacereleased=true;
	else if (spacereleased)
	{
	//goto next screen
	}
}



/*

	APP STUFF
*/

void app_intro_input()
{
	if (!key[KEY_SPACE])
		spacereleased=true;
	else if (spacereleased)
	{
		statetimer=max(110,statetimer);
		spacereleased=false;
	//goto next screen
	}
}


void app_introloop()
{
statetimer++;
app_intro_input();

if (statetimer<120)
{
		print_text("games",3,2*20);
		print_text("increpare",3,3*20);
		print_text("presents",3,4*20);
}
else
{
	appstate=app_select;
	menuitem=0;
}


}

void app_selectinput()
{
if (menuflicker>0)
{
	menuflicker--;
	
	if (menuflicker==0)
	{
		
		
		switch (menuitem){
			case 0:
				appstate=app_mm;
				gamestate=mm_intro;
				blankscreen();
				break;
			case 1:
				appstate=app_sc;
				gamestate=sc_title;
				gravitytimer=0;
				blankscreen();
				break;
			case 2:
				appstate=app_zeppelin;
				gamestate=zeppelin_title;
				blankscreen();
				break;
			case 3:
				appstate=app_panda;
				gamestate=panda_title;
				statetimer=0;
				blankscreen();
				break;															
		}
		
		
		menuitem=0;
		statetimer=0;
		spacereleased=false;
	}		
		
		
		
		
		
		
}
else
{		
	
	if (!key[KEY_SPACE]&&!key[KEY_UP]&&!key[KEY_DOWN])
		spacereleased=true;
	else if (spacereleased)
	{
		if (key[KEY_SPACE])
		{	
			menuflicker=flickeramount;
			playsample(s_selectitem);
		}
		else if (key[KEY_UP])
		{

			menuitem=(menuitem+3)%4;
			spacereleased=false;
			playsample(s_select);
		}		
		else if (key[KEY_DOWN])
		{
			menuitem=(menuitem+1)%4;
			spacereleased=false;
			playsample(s_select);
		}
	//goto next screen
	}
}
}

const char *gametitles[4] = {
"lady million",
"biocollect",
"zeppelin",
"sick panda"
};

void app_selectloop()
{
app_selectinput();
	
	if (appstate==app_select)
	{
print_text("select game",0,10);

for (int i=0;i<4;i++)
	if ((menuitem!=i)||(menuflicker%2==0))
		print_text(gametitles[i],11+(menuitem==i)*5,40+20*i);
	}
}



/*
 
 
	ZEPPELIN STUFF
 
 */

#include "zeppelinstructs.h"

void zeppelin_levelloop()
{
	
	for (int i=0;i<entitycount;i++)
		entities[i]->move();
	
	
	for (int i=0;i<entitycount;i++)
		entities[i]->draw();

	
}

void zeppelin_initlevel()
{
	
	//player always has index 1, boss transition always has index 2;
	addentity(new Zeppelin_player());
}


void zeppelin_titleinput()
{
	if (menuflicker==0)
	{
		if (!key[KEY_SPACE])
			spacereleased=true;
		else if (spacereleased)
		{
			menuflicker=flickeramount;
			spacereleased=false;
			playsample(s_select);
			//goto next screen
		}
	}
	else 
	{
		menuflicker--;
		if (menuflicker==0)
		{
			gamestate=zeppelin_level;
			zeppelin_initlevel();
			menuitem=0;	
			statetimer=0;
			blankscreen();		
		}
		
	}
}


void zeppelin_titleloop()
{
	
	zeppelin_titleinput();
	
	print_text("zepelin",3,2*20);
	print_text("lciv",3,3*20);
	if (menuflicker%2==0)
		print_text("press start",3,5*20);
}



/*

	PANDA STUFF
	
*/



void panda_initlevel()
{

	//player always has index 1, boss transition always has index 2;
	addentity(new Panda(120,100));
}


void panda_titleinput()
{
	if (menuflicker==0)
	{
	if (!key[KEY_SPACE])
		spacereleased=true;
	else if (spacereleased)
	{
		menuflicker=flickeramount;
		spacereleased=false;
		playsample(s_select);
	//goto next screen
	}
	}
	else 
	{
		menuflicker--;
		if (menuflicker==0)
		{
			gamestate=panda_level;
			panda_initlevel();
			menuitem=0;	
			statetimer=0;
			blankscreen();		
		}
			
	}
}


void panda_titleloop()
{

	panda_titleinput();

		print_text("sick",3,2*20);
		print_text("panda",3,3*20);
		if (menuflicker%2==0)
			print_text("press start",3,5*20);
}


void pandadraw()
{
//	rectfill(buffer,tilesize,tilesize,tilesize*9-1,tilesize*7-2,makecol(255,255,255));
	for (int i=1;i<9;i++)
		for (int j=1;j<7;j++)
			blit(panda_floortile,buffer,0,0,i*tilesize,j*tilesize,tilesize,tilesize);
//draw cage
	blit(panda_cagetiles[0][0],buffer,0,0,0,0,tilesize,tilesize);		
	blit(panda_cagetiles[1][0],buffer,0,0,tilesize,0,tilesize,tilesize);		
	blit(panda_cagetiles[0][1],buffer,0,0,0,tilesize,tilesize,tilesize);		

	blit(panda_cagetiles[4][0],buffer,0,0,tilesize*9,0,tilesize,tilesize);		
	blit(panda_cagetiles[4][1],buffer,0,0,tilesize*9,tilesize,tilesize,tilesize);		
	blit(panda_cagetiles[3][0],buffer,0,0,tilesize*8,0,tilesize,tilesize);		

	blit(panda_cagetiles[0][4],buffer,0,0,0,tilesize*7,tilesize,tilesize);		
	blit(panda_cagetiles[1][4],buffer,0,0,tilesize,tilesize*7,tilesize,tilesize);		
	blit(panda_cagetiles[0][3],buffer,0,0,0,tilesize*6,tilesize,tilesize);		

	blit(panda_cagetiles[4][4],buffer,0,0,tilesize*9,tilesize*7,tilesize,tilesize);		
	blit(panda_cagetiles[4][3],buffer,0,0,tilesize*9,tilesize*6,tilesize,tilesize);		
	blit(panda_cagetiles[3][4],buffer,0,0,tilesize*8,tilesize*7,tilesize,tilesize);		
		
	for (int i=2;i<8;i++)
		{
			blit(panda_cagetiles[2][0],buffer,0,0,i*tilesize,0,tilesize,tilesize);

			blit(panda_cagetiles[2][4],buffer,0,0,i*tilesize,tilesize*7,tilesize,tilesize);			
		}
	for (int j=2;j<6;j++)
		{
			blit(panda_cagetiles[0][2],buffer,0,0,0,j*tilesize,tilesize,tilesize);

			blit(panda_cagetiles[4][2],buffer,0,0,tilesize*9,j*tilesize,tilesize,tilesize);			
		}
	
	
	entities[0]->draw();
	blit(panda_healthgauge,buffer,0,0,tilesize,tilesize*8-tilesize/2,tilesize*8,tilesize);
	
	if (entities[0]->damage<41)
		rectfill(buffer,18+entities[0]->damage*3,115+tilesize/2,140,124+tilesize/2,makecol(0,0,0));
}

void panda_levelloop()
{
		if (statetimer<50)
				statetimer++;
		entities[0]->move();

		pandadraw();
}



/*

	SPECIMENT COLLECTOR STUFF
*/



void sc_initlevel()
{

	//player always has index 1, boss transition always has index 2;
	addentity(new Collector(17,-90));
	for (int i=0;i<30;i++)
		addentity(new Specimen(-(rand()%1000)-30));
}



void sc_titleinput()
{
	if (menuflicker==0)
	{
	if (!key[KEY_SPACE])
		spacereleased=true;
	else if (spacereleased)
	{
		menuflicker=flickeramount;
		spacereleased=false;
	//goto next screen
	}
	}
	else
	{
		menuflicker--;
		if (menuflicker==0)
		{
			gamestate=sc_level;
			sc_initlevel();
			blankscreenleavemusic();
			menuitem=0;			
		}
	}
}


void sc_titleloop()
{

	sc_titleinput();

		print_text("specimen",3,2*20);
		print_text("collector",3,3*20);
		if (menuflicker%2==0)
			print_text("press start",3,5*20);

}


void scdraw()
{
	
	rectfill(buffer,0,0,tilesize*10,tilesize*6,makecol(255,255,255));

	int x=entities[0]->x;

	int xoff=0;
	int yoff=0;
	if (gravitytimer>(maxgravitytimer+200))
	{
		xoff=rand()%(tilesize*((gravitytimer-maxgravitytimer-200)/200+1));
		if (gravitytimer>maxgravitytimer+400)
		{
			yoff=rand()%(tilesize*((gravitytimer-maxgravitytimer-400)/200+1));
		}
	}
	//parallax
	for (int j=0;j<6;j++)
		for (int i=-1;i<11;i++)
		{
			if (j>0)
				masked_blit(sc_leveltiles[1][0],buffer,0,0,i*tilesize-(((x+62)/8+xoff)%tilesize),j*tilesize+yoff,tilesize,tilesize);
			if(j>2)
				masked_blit(sc_leveltiles[1][0],buffer,0,0,i*tilesize-(((x+123)/4+xoff/2)%tilesize),j*tilesize+4+yoff/2,tilesize,tilesize);
			if(j>3)
				masked_blit(sc_leveltiles[1][0],buffer,0,0,i*tilesize-(((x+162)/2+xoff/4)%tilesize),j*tilesize+2+yoff/4,tilesize,tilesize);
		}
	
	rectfill(buffer,-x+tilesize*4,0,tilesize*4-x+tilesize*4,tilesize*6,makecol(255,255,255));
	vline(buffer,-x+tilesize*4,0,tilesize*6,makecol(0,0,0));
	vline(buffer,-x+tilesize*4+tilesize*4,0,tilesize*6,makecol(0,0,0));

	for (int j=6;j<9;j++)
		for (int i=-1;i<11;i++)
		{
			masked_blit(sc_leveltiles[3][0],buffer,0,0,i*tilesize-((x+15)%tilesize),j*tilesize,tilesize,tilesize);
		}


	entities[0]->draw();

	for (int i=1;i<entitycount;i++)
		if (entities[i]->material)
			entities[i]->draw();
		
	for (int i=1;i<entitycount;i++)
		if (!entities[i]->material)
			entities[i]->draw();
		
	if (gravitytimer>maxgravitytimer+600)
				print_text("i like cheese",0+(rand()%6),100+(rand()%6));
				
	print_num(score,9*tilesize,110);
	
}

void sc_levelloop()
{

		for (int i=0;i<entitycount;i++)
			entities[i]->move();

		gravitytimer++;
		if (gravitytimer==maxgravitytimer+1)
		{
			entities[0]->hit(0);//hit is alias for drop in collector
		}
		
		if (gravitytimer>maxgravitytimer)
				for (int i=0;i<entitycount;i++)
					entities[i]->y--;
			scdraw();
}




/*

	LADY MILLION STUFF

*/


void mm_levelloop()
{

	if ((endtimer==0)&&(starttimer==0))
	{

			//if (gamestate==(mm_level||mm_bosstransition))
			for (int i=0;i<entitycount;i++)
				entities[i]->move();
				
			player->anydamage();
			//sound stuff

			if (playfull) {
				playsample(s_fullplat);
				playfull=false;
			}
			else if (playhalf) {
				playsample(s_halfplat);
				playhalf=false;
			}
	}	

		mmdraw();

	if (endtimer>0)
	{
		endtimer--;
		if (endtimer==0)
		{
		if (playerdead)
		{
			
			bool lastlevel=true;
			
			for (int i=0;i<4;i++)
				if (!mm_completed[i])
					lastlevel=false;
			
			deleteallentities();
			gamestate=mm_passworddisplay;
			blankscreen(false);
			statetimer=0;
			playerdead=false;
		}
		else if (bossdead)
		{
			
			bool lastlevel=true;
			
			for (int i=0;i<4;i++)
				if (!mm_completed[i])
					lastlevel=false;
			
			if (lastlevel&&(level==4))
			{
				deleteallentities();
				gamestate=mm_outro;
				blankscreen();
				statetimer=0;
				bossdead=false;
			}
			else
			{
			deleteallentities();
			if (mm_completed[level])
			{
				gamestate=mm_passworddisplay;
				statetimer=0;
			}
			else 
			{
				gamestate=mm_getweapon;
				statetimer=0;
				mm_completed[level]=true;
			}
			blankscreen();
	
			}
		}
	}
	}
	
	if (starttimer>0)
	{
		starttimer--;
	}
}

void mm_introinput()
{//menuflicker doesn't cause actual flickering here...
	if (menuflicker==0)
	{
	if (!key[KEY_SPACE])
		spacereleased=true;
	else if (spacereleased)
	{
		menuflicker=5;	
		spacereleased=false;
	//goto next screen
	}
	}
	else
	{
		menuflicker--;
		if (menuflicker==0)
		{
			statetimer++;
		}
	}
}

void mm_introloop()
{

mm_introinput();

if (statetimer<introstates)
{
//draw the text
for (int i=0;i<4;i++)
	{
		print_text(introtext[statetimer][i],3,32+i*20);
	}
}
else
	{
		gamestate=mm_title;
		blankscreen(false);
		statetimer=0;
	}

}


void mm_titleinput()
{
	if (menuflicker==0)
	{
	if (!key[KEY_SPACE]&&!key[KEY_UP]&&!key[KEY_DOWN])
		spacereleased=true;
	else if (spacereleased)
	{
		if (key[KEY_SPACE])
		{	
			menuflicker=flickeramount;
			playsample(s_selectitem);
		}
		else if (key[KEY_UP]||key[KEY_DOWN])
		{
			statetimer=(statetimer+1)%2;
			spacereleased=false;
			playsample(s_itemchange);
		}
	//goto next screen
	}
	}
	else
	{
		menuflicker--;
		if (menuflicker==0)
		{
			if (statetimer==0)
				gamestate=mm_select;
			else
			{
				for (int i=0;i<5;i++)
					mm_passworddat[i]=false;
				validpassword=false;				
				gamestate=mm_password;
			}
			blankscreen(false);
			statetimer=0;
			spacereleased=false;	
		}
	}
}

char *mmtitletext[2]={"start","password"};

void mm_titleloop()
{
mm_titleinput();

	if (gamestate==mm_title)
	{
masked_blit(mmtitlebmp,buffer,0,0,0,0,160,144);

for (int i=0;i<2;i++)
	if ((statetimer!=i)||(menuflicker%2==0))
	print_text(mmtitletext[i],41+(statetimer==i)*5,80+20*i);
	}	

}


void mm_selectinput(bool lastlevel)
{
	
	if (menuflicker==0)
	{
	if (!key[KEY_SPACE]&&!key[KEY_UP]&&!key[KEY_DOWN]&&!key[KEY_LEFT]&&!key[KEY_RIGHT])
		spacereleased=true;
	else if (spacereleased)
	{
		
		if (!lastlevel)
		{
			if (key[KEY_SPACE])
			{
				menuflicker=flickeramount;
				playsample(s_selectstage);
			}
			else if (key[KEY_UP]||key[KEY_DOWN])
			{
				statetimer=statetimer+2*(2*(statetimer/2==0)-1);
				spacereleased=false;
				playsample(s_itemchange);

			}
			else if (key[KEY_LEFT]||key[KEY_RIGHT])
			{
				statetimer=statetimer+1*(2*(statetimer%2==0)-1);
				spacereleased=false;
				playsample(s_itemchange);
			}
		}
		else
		{
			if (key[KEY_SPACE])
			{
				menuflicker=flickeramount;
				playsample(s_selectstage);
			}
			else if (key[KEY_UP])
			{
				if (statetimer<2) statetimer+=2;
				else if (statetimer<4) statetimer=4;
				else statetimer=0;
				playsample(s_itemchange);
				spacereleased=false;
			}
			else if (key[KEY_DOWN])
			{
				if (statetimer<2) statetimer=4;
				else if (statetimer<4) statetimer-=2;
				else statetimer=2;
				playsample(s_itemchange);
				spacereleased=false;			
			}
			else if (key[KEY_LEFT])
			{
				if (statetimer==4) statetimer=0;
				else if (statetimer%2==0) statetimer++;
				else statetimer=4;
				playsample(s_itemchange);
				spacereleased=false;
			}
			else if (key[KEY_RIGHT])
			{
				if (statetimer==4) statetimer=1;
				else if (statetimer%2==0) statetimer=4;
				else statetimer--;
				playsample(s_itemchange);
				spacereleased=false;			
			}
			
		}
	}
	}
	else {
		menuflicker--;
		
		if (menuflicker==0)
		{
			level=statetimer;
			statetimer=0;
			gamestate=mm_levelintro;
			spacereleased=false;
			blankscreen();
		}
	}


}

void mm_selectloop()
{
	bool lastlevel=true;

	for (int i=0;i<4;i++)
		if (!mm_completed[i])
			lastlevel=false;
	
	mm_selectinput(lastlevel);
	
	if (gamestate==mm_select)
	{
	print_text("select level",0,0);

	
	for (int i=0;i<4;i++)
	{
		int x=tilesize*(3+2*(i%2));
		int y=tilesize*(3+2*(i/2));
		rectfill(buffer,x-2,y-2,x+tilesize+1,y+tilesize+1,makecol(255,255,255));
		masked_blit(leveltiles[9+i][0],buffer,0,0,x,y,tilesize,tilesize);
		if (mm_completed[i])
			masked_blit(leveltiles[4][8],buffer,0,0,x,y,tilesize,tilesize);
		if ((statetimer==i)&&(menuflicker%2==0))
			rect(buffer,x-4,y-4,x+tilesize+3,y+tilesize+3,makecol(255,255,255));
	}
	
	if (lastlevel)
	{
		int x=tilesize*4;
		int y=tilesize*4;
		rectfill(buffer,x-2,y-2,x+tilesize+1,y+tilesize+1,makecol(255,255,255));
		masked_blit(leveltiles[9+4][0],buffer,0,0,x,y,tilesize,tilesize);
		if ((statetimer==4)&&(menuflicker%2==0))
		{
			rect(buffer,x-3,y-3,x+tilesize+2,y+tilesize+2,makecol(0,0,0));
			rect(buffer,x-4,y-4,x+tilesize+3,y+tilesize+3,makecol(255,255,255));
		}
	}
	}
}

void mm_pauseinput()
{
	//space_released functions as z-release here
	if (!zreleased)
	{	if (!key[KEY_Z])
			zreleased=true;
	}
	else if (key[KEY_Z])
	{
		player->weapon=statetimer;
		gamestate=oldstate;
		spacereleased=false;
		zreleased=false;
	}

	if (!key[KEY_SPACE]&&!key[KEY_UP]&&!key[KEY_DOWN]&&!key[KEY_LEFT]&&!key[KEY_RIGHT])
		spacereleased=true;
	else if (spacereleased)
	{
		if (key[KEY_SPACE])
		{
			player->weapon=statetimer;
			gamestate=oldstate;
			spacereleased=false;
		}
		else if (key[KEY_UP]||key[KEY_DOWN])
		{
			int a= (key[KEY_UP]?-1:1);
			while (true)
			{
				statetimer=(statetimer+a+5)%5;	
				if (statetimer==0)
					break;
				else if (mm_completed[statetimer-1])
					break;
			}
			spacereleased=false;	
		}
	}
}


void mm_drawpause()
{

	//3: draw health bar
	blit(healthbar[0],buffer,0,0,3,9,9,47);
	blit(healthbar[1],buffer,2,1,5,10+(maxhealth-player->health)*2,5,(player->health)*2);
	blit(leveltiles[6][1+statetimer],buffer,0,0,4,48,7,7);

	if (oldstate==mm_boss)
	{
		blit(healthbar[0],buffer,0,0,160-3-9,9,9,47);
		blit(healthbar[1],buffer,2,1,160-3-9+2,10+(maxhealth-boss->health)*2,5,(boss->health)*2);
	}
	
	for (int i=0;i<5;i++)
	{
		
		bool draw=false;
		if (i==0)
			draw=true;
		else if (mm_completed[i-1])
			draw=true;
		if (draw)
		{
			masked_blit(leveltiles[8][4],buffer,0,0,41,(tilesize+4)*(i+1)+3,7,7);
			print_textsmall(gunname[i],50,(tilesize+4)*(i+1)+2);
			if ((statetimer==i)&&(gamestate==mm_paused))
				rect(buffer,40-2,(tilesize+4)*(i+1),140,(tilesize+4)*(i+2)-7,makecol(255,255,255));
		}
	}
	
	
}

void mm_pauseloop()
{
	mm_pauseinput();
	
	mm_drawpause();
}

/*
 
 5 bits
 2^5=32 combinations
 27 is coprime with 32
 
 ABCD0
 gets encoded as
 !D,!0,A,!C,B
 */

int statetonum()
{
	return mm_completed[0]+2*mm_completed[1]+4*mm_completed[2]+8*mm_completed[3];
}

int passwordtonum()
{
	return mm_passworddat[0]+2*mm_passworddat[1]+4*mm_passworddat[2]+8*mm_passworddat[3]+16*mm_passworddat[4];
}

const int cryptkey=3;

int encryptnum(int n)
{
	return (n+cryptkey)%32;
}

int decryptnum(int n)
{
	return (n+32-cryptkey)%32;
}

bool validnum(int n)
{
	if ((n/16)%2==0)
		return true;
	else
		return false;
}

void numtostate(int n)
{
	for (int i=0;i<4;i++)
	{
		mm_completed[i]=n%2;
		n/=2;
	}
}

void numtopasswd(int n)
{
	for (int i=0;i<5;i++)
	{
		mm_passworddat[i]=n%2;
		n/=2;
	}
}

void getpassword()
{
	numtopasswd(encryptnum(statetonum()));
	/*
	for (int i=0;i<4;i++)
	{
		mm_passworddat[i]=mm_completed[i];
	}
	mm_passworddat[4]=0;
*/
}

bool trysetpassword()
{
	int n=decryptnum(passwordtonum());
	
	//#1 check if it's correct
	if (validnum(n))
	{
	//#2 apply
		numtostate(n);
		return true;
	}
	else return false;
}


void mm_passwordinput()
{
	if (menuflicker==0)
	{
	if (!key[KEY_SPACE]&&!key[KEY_UP]&&!key[KEY_DOWN]&&!key[KEY_LEFT]&&!key[KEY_RIGHT])
		spacereleased=true;
	else if (spacereleased)
	{
			if (key[KEY_SPACE])
			{
				if (trysetpassword())
				{
					validpassword=true;
					playsample(s_goodpassword);
				}
				else
					playsample(s_badpassword);
				menuflicker=flickeramount;
			}
			else if (key[KEY_UP]||key[KEY_DOWN])
			{
				mm_passworddat[statetimer]=!mm_passworddat[statetimer];
				spacereleased=false;
				playsample(s_passwordchange);
			}
			else if (key[KEY_LEFT])
			{
				statetimer=(statetimer-1+5)%5;
				spacereleased=false;
				playsample(s_select);
			}
			else if (key[KEY_RIGHT])	
			{
				statetimer=(statetimer+1)%5;
				spacereleased=false;
				playsample(s_select);			
			}
	}
	}
	else
	{
		menuflicker--;
		
		if ((menuflicker==0)&&(validpassword))
		{
			bool lastlevel=true;
			
			for (int i=0;i<4;i++)
				if (!mm_completed[i])
					lastlevel=false;
			
			gamestate=mm_select;
			if (lastlevel) statetimer=4;
			else statetimer=0;
			spacereleased=false;	
		}
	}

}

void mm_passwordloop()
{
	print_text("enter passwd",0,0);

mm_passwordinput();

	if (gamestate==mm_password)
	{
	if (menuflicker%2==0)
	for (int i=0;i<5;i++)
	{
		int x=tilesize*(2*i)+tilesize/2;
		int y=tilesize*3;
		rectfill(buffer,x-2,y-2,x+tilesize+1,y+tilesize+1,makecol(255,255,255));
		masked_blit(leveltiles[5][4+!mm_passworddat[i]],buffer,0,0,x,y,tilesize,tilesize);
		if (statetimer==i)
			rect(buffer,x-4,y-4,x+tilesize+3,y+tilesize+3,makecol(255,255,255));

//	[5][4]

	}
	}

}


void outro_input()
{
	if (menuflicker==0)
	{
	if (!key[KEY_SPACE])
		spacereleased=true;
	else if (spacereleased)
	{
		menuflicker=10;
		//goto next screen
	}
	}
	else {
		menuflicker--;
		if (menuflicker==0)
		{
			if (statetimer<(outrostates-1))
				statetimer++;
			spacereleased=false;
		}
	}

}

void mm_outroloop()
{

outro_input();

for (int i=0;i<4;i++)
	{
		print_text(outrotext[statetimer][i],3,32+i*20);
	}
if (statetimer<outrostates-1)
	masked_blit(leveltiles[4][(statetimer<=4)],buffer,0,0,1,1,tilesize,tilesize);
else
{
	masked_blit(leveltiles[4][0],buffer,0,0,tilesize/2,100,tilesize,tilesize);
	masked_blit(leveltiles[4][0],buffer,0,0,tilesize/2,10,tilesize,tilesize);
	for (int i=0;i<5;i++)
	{
		masked_blit(leveltiles[9+i][0],buffer,0,0, (i+1)*(tilesize+tilesize/2)+tilesize/2,100,tilesize,tilesize);
		masked_blit(leveltiles[9+i][0],buffer,0,0, (i+1)*(tilesize+tilesize/2)+tilesize/2,10,tilesize,tilesize);
	}
}
}

void mm_levelintroinput()
{
	statetimer++;
	
	if (statetimer==80)
		{
			gamestate=mm_level;
			mm_initlevel();
			spacereleased=false;
			blankscreen(true);
			statetimer=0;
		}
}

void mm_levelintroloop()
{
	
	mm_levelintroinput();
	
	
	if (statetimer>20)
	{
		print_text_to(bossname[level],(statetimer-20)/3+1,20,tilesize*5);
	}
	
	
	rectfill(buffer, tilesize*4-1, tilesize+tilesize/2-1, tilesize*4+tilesize, tilesize+tilesize+tilesize/2, makecol(255,255,255));
	
	//want transition to last 15 ticks
		masked_blit(leveltiles[9+level][0],buffer,0,0,tilesize*4,tilesize+tilesize/2,tilesize,tilesize*4);
	
}

void mm_getweaponinput()
{
	int n=	(strlen(gunname[level+1])+8)*3;
	if (statetimer<	n)
	{
		statetimer++;
		if (statetimer%3==0)
			playsample(s_barriertick);
	}
	if (menuflicker==0)
	{
		if (!key[KEY_SPACE])
			spacereleased=true;
		else if (spacereleased)
		{
			menuflicker=10;
			//goto next screen
		}
	}
	else {
		menuflicker--;
		if ((menuflicker==0)&&(statetimer==n))
		{
			level=statetimer;
			gamestate=mm_passworddisplay;
			getpassword();
			spacereleased=false;
			blankscreen(false);
			statetimer=0;
		}
	}
	
}

void mm_getweaponloop()
{
	if (statetimer<=20)
	{
		explode(leveltiles[9+level][0], tilesize*4, 100, 20-statetimer);
	}
	
	mm_getweaponinput();
	
	
	print_text_to("you got",statetimer/3,20,20);
	print_text_to(gunname[level+1],statetimer/3-8,20,40);

	
	if (statetimer<=20)
	{
		for (int i=0;i<tilesize;i++)
			masked_blit(playertiles[1],buffer,0,i,tilesize*4+(((i%2)*2)-1)*(20-statetimer)*(20-statetimer),100+i,tilesize,1);
	}
	else
			masked_blit(playertiles[1],buffer,0,0,tilesize*4,100,tilesize,tilesize);
	
}

void mm_passworddisplayinput()
{
	if (statetimer<30)
		statetimer++;
	if (menuflicker==0)
	{
		if (!key[KEY_SPACE])
			spacereleased=true;
		else if (spacereleased)
		{
			menuflicker=10;
			//goto next screen
		}
	}
	else {
		menuflicker--;
		if ((menuflicker==0)&&(statetimer==30))
		{
			level=statetimer;
			gamestate=mm_select;
			spacereleased=false;
			
			//recalc last level
			bool lastlevel=true;
			
			for (int i=0;i<4;i++)
				if (!mm_completed[i])
					lastlevel=false;
			
			if (lastlevel) statetimer=4;
			else statetimer=0;
			blankscreen(false);
		}
	}
}

void mm_passworddisplayloop()
{
	
	mm_passworddisplayinput();

	getpassword();
	
	print_text("password",0,0);
	
	for (int i=0;i<5;i++)
	{
	int x=tilesize*(2*i)+tilesize/2;
	int y=tilesize*3;
	rectfill(buffer,x-2,y-2,x+tilesize+1,y+tilesize+1,makecol(255,255,255));
	masked_blit(leveltiles[5][4+!mm_passworddat[i]],buffer,0,0,x,y,tilesize,tilesize);
	}
}


int main()
{

	init();
	int oldappstate=-1;
	int oldgamestate=-1;
	
// only call this when you want to start the level I guess	mm_initlevel();
	while (!key[KEY_ESC]) { 
	
		//clear buffer
		clear_to_color(buffer,makecol(0,0,0));
		
		if (key[KEY_R])
		{
			deleteallentities();
			for (int i=0;i<4;i++)
				mm_completed[i]=false;
			appstate=app_intro;
			statetimer=0;
			blankscreen();
		}
		else if (screenblank==0)
		{
		switch (appstate){
		case app_intro:
			app_introloop();
			break;
		case app_select:
			app_selectloop();
			break;
		case app_mm:
			switch (gamestate)
			{
				case mm_intro:
					mm_introloop();
					break;
				case mm_title:
					mm_titleloop();
					break;
				case mm_select:
					mm_selectloop();
					break;
				case mm_password:
					mm_passwordloop();
					break;
				case mm_levelintro:
					mm_levelintroloop();
					break;
				case mm_level:
				case mm_bosstransition:
				case mm_boss:
					mm_levelloop();
					break;
				case mm_paused:
					mm_pauseloop();
					break;
				case mm_passworddisplay:
					mm_passworddisplayloop();
					break;
				case mm_getweapon:
					mm_getweaponloop();
					break;
				case mm_outro:
					mm_outroloop();
					break;
			}
			break;
		case app_sc:
			switch (gamestate)
			{
				case sc_title:
					sc_titleloop();
					break;
				case sc_level:
					sc_levelloop();
					break;	
			}
			break;
		case app_panda:
			switch (gamestate)
			{
				case panda_title:
					panda_titleloop();
					break;
				case panda_level:
					panda_levelloop();
					break;	
			}
			break;	
			case app_zeppelin:
				switch (gamestate)
			{
				case zeppelin_title:
					zeppelin_titleloop();
					break;
				case zeppelin_level:
					zeppelin_levelloop();
					break;	
			}
				break;						
		}
		
			if (screenblank==0)
			{
		if ((oldappstate!=appstate)|(oldgamestate!=gamestate)&&(!((oldappstate==app_mm)&&(oldgamestate==mm_paused))))
			switchmusic();
		oldappstate=appstate;
		oldgamestate=gamestate;
			}
		}
		else{
				screenblank--;	
			if (bossdead&&(mm_completed[level]))
			 {
				 explode(leveltiles[9+level][0], tilesize*4, 100, 100+screenblank);	 
			 }
			
				if (screenblank==0)
				{
					if ((oldappstate!=appstate)|(oldgamestate!=gamestate)&&(!((oldappstate==app_mm)&&(oldgamestate==mm_paused))))
						switchmusic();
					oldappstate=appstate;
					if (bossdead) bossdead=false;
					oldgamestate=gamestate;	
					if ((appstate==app_mm)&&(gamestate==mm_level))
						playsample(s_teleport);
				}
		}
		
		pollmusic();

		
		/* control timing */
		while (ticks<1) {
			rest(0);
		}
		ticks=0;
		++frames;

		vsync();
		acquire_screen();
		stretch_blit(buffer,screen,0,0,160,144,70,3,660,594);
		release_screen();
	}

	deinit();
	return 0;
}
END_OF_MAIN()


void init()
{
	allegro_init();
	int depth = desktop_color_depth();
	if (depth == 0) depth = 8;
	set_color_depth(depth);
	int res = set_gfx_mode(GFX_AUTODETECT_FULLSCREEN, 800, 600, 0, 0);
	disable_hardware_cursor();

	if (res != 0) {
		allegro_message(allegro_error);
		exit(-1);
	}

	install_timer();
	install_keyboard();

	install_int_ex(second_counter, BPS_TO_TIMER(1));
	install_int_ex(ticker, BPS_TO_TIMER(30));

	LOCK_FUNCTION(second_counter);
	LOCK_VARIABLE(fps);
	LOCK_VARIABLE(frames);
	LOCK_FUNCTION(ticker);
	LOCK_VARIABLE(ticks);

	background=create_bitmap(1,1);

	initgraphics();
	
	spacereleased=false;
	statetimer=0;
	menuitem=0;
	blankscreen();

	for (int i=0;i<4;i++)
		mm_completed[i]=false;
	gamestate=mm_intro;
	appstate=app_intro;
	
	playerdead=false;
	bossdead=false;
		
	srand ( time(NULL) );
	
	for (int i=0;i<360;i++)
	{
		const float Pi=3.1415926535;
		Cos[i]=cos((Pi*i)/180.0f)*radius;
		Sin[i]=sin((Pi*i)/180.0f)*radius;
	}
	initaudio();
}

//put these further up at some point



void blankscreenleavemusic()
{
	screenblank=blanklength/2;
}

void blankscreen(bool longpause)
{
	if (longpause)
		screenblank=blanklength;
	else 
		screenblank=blanklength/2;
	stopmusic();
}


//HMUSIC chan[musiccount];	// the channel... HMUSIC or HSTREAM
//HMUSIC curplay;
//HSAMPLE  sfx[24];

void switchmusic()
{
	
	int i=-1;
	switch (appstate){
		case app_intro:
			i=0;
			break;
		case app_select:
			i=1;
			break;
		case app_mm:
		{
			switch (gamestate)
			{
				case mm_intro:
					i=2;
					break;
				case mm_title:
					i=3;
					break;
				case mm_password:
					i=4;
					break;
				case mm_select:
					i=5;
					break;
				case mm_levelintro:
					i=20;
					break;
				case mm_level:
					i=6+level;
					break;
				case mm_paused:
					return;//do nothing
					break;
				case mm_bosstransition:
					//stop the music temporarily
					stopmusic();
					break;
				case mm_boss:
					i=11;
					break;
				case mm_bossdead:
					stopmusic();
					break;
				case mm_passworddisplay:
					i=18;
					break;
				case mm_getweapon:
					i=19;
					break;
				case mm_outro:
					i=12;
					break;
			}
			
		}	
			break;
		case app_sc:
			if (gamestate==sc_title)
				i=13;
			else
				return;
			break;	
		case app_panda:
			if (gamestate==panda_title)
				i=14;
			else
				i=15;
			break;
		case app_zeppelin:
			stopmusic();
		break;	
	}
	
	if (i>=0)
		playmusic(i);
}

BITMAP* loadbmp(string s)
{
	return load_bitmap(("bmp/"+s).c_str(), NULL);
}


string bmpfile[6]={
"tiles.bmp",
"font.bmp",
"mmtitle.bmp",
"specimen.bmp",
"panda.bmp",
"zepimgs.bmp"
};

void initgraphics()
{
	
	
	//load graphics
	buffer=create_bitmap(160,144);
	
	BITMAP *temp= loadbmp(bmpfile[0]);
	
	
	//megaman stuff
	//load level tilesets
	for (int i=0;i<15;i++)
		for (int j=0;j<10;j++) {
			leveltiles[i][j]=create_bitmap(tilesize,tilesize);
			blit(temp,leveltiles[i][j],j*tilesize,i*tilesize,0,0,tilesize,tilesize);
		}
	
	//load player sprites
	
	for (int i=0;i<4;i++) {
		playertiles[i]=create_bitmap(tilesize,tilesize);
		blit(temp,playertiles[i],i*tilesize,4*tilesize,0,0,tilesize,tilesize);
	}
	
	for (int i=0;i<5;i++) {
		shottiles[i]=create_bitmap(tilesize,tilesize);
		blit(temp,shottiles[i],(i+1)*tilesize,7*tilesize,0,0,tilesize,tilesize);
	}
	
	for (int i=0;i<2;i++) {
		healthbar[i]=create_bitmap(9,47);
		blit(temp,healthbar[i],(6+i)*tilesize,4*tilesize,0,0,9,47);
	}
	
	BITMAP *fontbmps =  loadbmp(bmpfile[1]);
	for (int i=0;i<36;i++)
	{
		fontbmp[i]=create_bitmap(3,5);
		blit(fontbmps,fontbmp[i],i*4,0,0,0,3,5);
	}
	destroy_bitmap(fontbmps);
	
	mmtitlebmp = loadbmp(bmpfile[2]);
	
	//specimen collector stuff
	destroy_bitmap(temp);
	
	temp= loadbmp(bmpfile[3]);
	
	//load level tilesets
	for (int i=0;i<14;i++)
		for (int j=0;j<10;j++) {
			sc_leveltiles[i][j]=create_bitmap(tilesize,tilesize);
			blit(temp,sc_leveltiles[i][j],j*tilesize,i*tilesize,0,0,tilesize,tilesize);
		}
	
	for (int i=0;i<8;i++)
	{
		sc_playersprite[i]=create_bitmap(sc_pwidth,sc_pheight);
		blit(temp,sc_playersprite[i],tilesize,i*tilesize,0,0,sc_pwidth,sc_pheight);	
	}
	
	sc_specimensprite[0]=create_bitmap(sc_swidth[0],sc_sheight[0]);
	blit(temp,sc_specimensprite[0],tilesize*3,0,0,0,sc_swidth[0],sc_sheight[0]);
	
	sc_specimensprite[1]=create_bitmap(sc_swidth[1],sc_sheight[1]);
	blit(temp,sc_specimensprite[1],tilesize*5,0,0,0,sc_swidth[1],sc_sheight[1]);
	
	//load panda stuff
	destroy_bitmap(temp);
	
	temp=loadbmp(bmpfile[4]);
	
	for (int i=0;i<4;i++)
		for (int j=0;j<3;j++)
		{
			panda_sprite[i][j]=create_bitmap(tilesize,tilesize);
			blit(temp,panda_sprite[i][j],j*tilesize,i*tilesize,0,0,tilesize,tilesize);
		}
	panda_healthgauge=create_bitmap(tilesize*8, tilesize);
	blit(temp,panda_healthgauge,tilesize,tilesize*8,0,0,tilesize*8,tilesize);
	
	panda_floortile=create_bitmap(tilesize,tilesize);
	blit(temp,panda_floortile,tilesize*3,0,0,0,tilesize,tilesize);
	
	for (int i=0;i<5;i++)
		for (int j=0;j<5;j++)
		{
			panda_cagetiles[i][j]=create_bitmap(tilesize,tilesize);
			blit(temp,panda_cagetiles[i][j],(3+i)*tilesize,(j+1)*tilesize,0,0,tilesize,tilesize);
		}
	//should destroy fontbmps
	destroy_bitmap(temp);
	//zeppelin stuff
	zepimgs=loadbmp(bmpfile[5]);
	zepletters=create_bitmap(160,144);
	
}




void deinit()
{
	clear_keybuf();
	/* add other deinitializations here */
}
